#include <stdlib.h>
#include "set.h"

Set addToSet(Set set, Element element)
{
    if (!setContainsElement(set, element))
    {
        Set toAdd = (Set)malloc(sizeof(SetItem));
        toAdd->element = element;
        toAdd->next = set;
        return toAdd;
    }
    else
    {
        return set;
    }
}

Set removeFromSet(Set set, Element element)
{
    if (compareElements(set->element, element) == 0)
    {
        return set->next;
    }
    else
    {
        return removeFromSet(set->next, element);
    }
}

boolean setContainsElement(Set set, Element element)
{
    if (set == NULL)
    {
        return false;
    }
    else if (compareElements(set->element, element) == 0)
    {
        return true;
    }
    else
    {
        return setContainsElement(set->next, element);
    }
}

int countElementsInSet(Set set)
{
    int count;
    for (count = 0; set != NULL; set = set->next, count++);
    return count;
}

Set setDifference(Set a, Set b)
{
    Set diff = NULL;
    while (a != NULL)
    {
        if (!setContainsElement(b, a->element))
        {
            diff = addToSet(diff, a->element);
        }
        a = a->next;
    }
    return diff;
}

Set setUnion(Set a, Set b)
{
    Set unionSet = NULL;
    while (a != NULL)
    {
        unionSet = addToSet(unionSet, a->element);
        a = a->next;
    }
    while (b != NULL)
    {
        unionSet = addToSet(unionSet, b->element);
        b = b->next;
    }
    return unionSet;
}

Set setIntersection(Set a, Set b)
{
    Set intersection = NULL;
    while (a != NULL)
    {
        if (setContainsElement(b, a->element))
        {
            intersection = addToSet(intersection, a->element);
        }
        a = a->next;
    }
    return intersection;
}

void saveSetToTxt(FILE *f, Set set)
{
    while (set != NULL)
    {
        saveElementToTxt(f, set->element);
        set = set->next;
    }
}

void readSetFromTxt(FILE *f, Set *set)
{
    Element e;
    *set = NULL;
    while (readElementFromTxt(f, &e))
    {
        *set = addToSet(*set, e);
    }
}

void printSet(Set set)
{
    while (set != NULL)
    {
        printElement(set->element);
        set = set->next;
    }
}
